module oc_mute_mod
  use sep
  use oc_file_mod
  use oc_adjnull_mod
  use mpi_sep
  implicit none

	integer, private :: taperx,tapery
	integer, private,allocatable :: ng(:) 
	integer, private,allocatable    :: intbegmute(:,:,:),intendmute(:,:,:)
	real, private    :: halfpi
  integer, private :: maxmem

contains

  !----------------------------------------------------------------
  subroutine oc_mute_init(nreg,opx,dpx,mute_modbeg,maxmem_in)
		integer, intent(in) :: nreg(:)
		real, intent(in) :: opx,dpx 
  	logical :: mute_beg
		real,allocatable    :: begmute(:,:,:),endmute(:,:,:)
    integer,            optional   :: maxmem_in
    logical,            optional   :: mute_modbeg
		integer  :: iz,ix,iy,ithread,ierr
		integer, external :: sreed
    character(len=128) :: junk

    maxmem=0; if(present(maxmem_in)) maxmem=maxmem_in
    mute_beg=.false.; if(present(mute_modbeg)) mute_beg=mute_modbeg 

		allocate(ng(size(nreg)))

		ng=nreg
	  call MPI_COMM_RANK(MPI_COMM_WORLD, ithread,ierr)

call mpi_barrier(mpi_comm_world,ierr)
 if(ithread==0)then


! What is the best way to get the mute in here?
		if(ng(4) .ne. 1) call seperr("h_y must equal 1 - CAM")

write(0,*)"mute_init1"
		allocate(endmute(ng(1),ng(2),ng(5)),intendmute(ng(1),ng(2),ng(5))) 
		allocate(intbegmute(ng(1),ng(2),ng(5)))
		intbegmute=1
		intendmute=ng(3)
		call from_param("taperx",taperx,5)

write(0,*)"mute_init2",ng(1),ng(2),ng(5),mute_beg
call from_param("muteend",junk)
call from_aux("muteend","n1",ierr)
write(0,*) "check this",ierr
		if(mute_beg) then
			allocate(begmute(ng(1),ng(2),ng(5)))
			if(ng(1)*ng(2)*ng(5)*4 .ne. sreed("mutebeg",begmute,size(begmute)*4)) &
				call seperr("trouble reading mutebeg") 
		end if
write(0,*)"mute_initx",ng(1)*ng(2)*ng(5),size(endmute)
!		if(4 .ne. sreed("muteend",endmute,4)) &
		if(ng(1)*ng(2)*ng(5)*4 .ne. sreed("muteend",endmute,size(endmute)*4)) &
			call seperr("trouble reading muteend") 
write(0,*)"mute_init3",opx,dpx,minval(endmute),maxval(endmute)
		do iz=1,ng(5)
			do iy=1,ng(2)
				do ix=1,ng(1)
					if(mute_beg) then
						intbegmute(ix,iy,iz)=(begmute(ix,iy,iz)-opx)/dpx+1.5
						if(intbegmute(ix,iy,iz) < 1) intbegmute(ix,iy,iz)=1
						if(intbegmute(ix,iy,iz) >ng(3)) intbegmute(ix,iy,iz)=ng(3)
					end if
					intendmute(ix,iy,iz)=(endmute(ix,iy,iz)-opx)/dpx+1.5
					if(intendmute(ix,iy,iz) < 1) intendmute(ix,iy,iz)=1
          if(intendmute(ix,iy,iz) >ng(3)) intendmute(ix,iy,iz)=ng(3)
					if(intendmute(ix,iy,iz) < intbegmute(ix,iy,iz)) intendmute(ix,iy,iz)=intbegmute(ix,iy,iz)
				end do
			end do	
		end do
write(0,*)"mute_init4",minval(intendmute),maxval(intendmute)
write(0,*)"mute_init5",minval(intbegmute),maxval(intbegmute)
!		if(any(endmute+taperx) > ng(3)) taperx=1
		halfpi=1.5707963
		if(mute_beg) deallocate(begmute)
    deallocate(endmute)
end if 
call mpi_barrier(mpi_comm_world,ierr)
  end subroutine oc_mute_init
  !----------------------------------------------------------------
  integer function oc_mutemod(adj,add, x_,yy_, op1,op2,op3,op4,op5,op6,op7,op8,op9) result(stat)
    logical,               intent(in)  :: adj,add
    character(len=128),    intent(in)  :: x_,yy_
    integer, external,     optional    :: op1,op2,op3,op4,op5,op6,op7,op8,op9
    type(fileinfo)                     :: filex,filey
    integer                            :: i,j,ithread,ierr
		integer  :: iz,ix,iy,nlen
    integer, external :: sreed
		complex, dimension(:,:,:,:), allocatable :: resid_in, resid_out 


	  call MPI_COMM_RANK(MPI_COMM_WORLD, ithread,ierr)
if(ithread==0) then!{


	  call oc_adjnull(adj,add,x_,yy_)

  	call oc_allocatefile(filex, x_,  maxmem); call sseek(x_, 0,0)
 	  call oc_allocatefile(filey, yy_, maxmem); call sseek(yy_,0,0)
 	  call oc_checksimilarity(filex,filey, "oc_weight")
	
		allocate(resid_in(filey%n(1),filey%n(2),filey%n(3),filey%n(4)))
		allocate(resid_out(filex%n(1),filex%n(2),filex%n(3),filex%n(4)))
	
		resid_out=0
		resid_in=0

write(0,*)"in oc_mute_mod",ng(1),ng(2),ng(5)
	
			if(.not. adj) then  !! x=w y{
         write(0,*)"mute_mod: forward",trim(x_)

				 do iz=1,ng(5)	
        	ierr=sreed(x_, resid_in, 8*filex%n(1)*filex%n(2)*filex%n(3)*filex%n(4))
					resid_out=0
					do iy=1,ng(2)
						do ix=1,ng(1)
						 resid_out(ix,iy,intbegmute(ix,iy,iz):intendmute(ix,iy,iz),:)=resid_in(ix,iy,intbegmute(ix,iy,iz):intendmute(ix,iy,iz),:)
            nlen=min(filex%n(3) - intendmute(ix,iy,iz), taperx)
					 do i=1,nlen
							resid_out(ix,iy,intendmute(ix,iy,iz)+i,:)=resid_in(ix,iy,intendmute(ix,iy,iz)+i,:)*((cos((halfpi/nlen)*(i-1)))**2)	
					 end do
						end do
					end do 
				 call sep_write(resid_out, yy_)	
				end do

			else                     !! y=w x !}{
         write(0,*)"mute_mod: adjoint",trim(yy_)
				 write(0,*)"check adjoint",minval(intbegmute),maxval(intbegmute),minval(intendmute),maxval(intendmute)	
				 do iz=1,ng(5)	
        	ierr=sreed(yy_, resid_out, 8*filex%n(1)*filex%n(2)*filex%n(3)*filex%n(4))
					resid_in=0
					do iy=1,ng(2)
						do ix=1,ng(1)

						 resid_in(ix,iy,intbegmute(ix,iy,iz):intendmute(ix,iy,iz),:)=resid_out(ix,iy,intbegmute(ix,iy,iz):intendmute(ix,iy,iz),:)
           nlen=min(filex%n(3) - intendmute(ix,iy,iz), taperx)
					 do i=1,nlen
							resid_in(ix,iy,intendmute(ix,iy,iz)+i,:)=resid_out(ix,iy,intendmute(ix,iy,iz)+i,:)*((cos((halfpi/nlen)*(i-1)))**2)	
					 end do
						end do
					end do 
				 call sep_write(resid_in, x_)	
				end do

			end if !}

				 deallocate(resid_in,resid_out)
 	  		 call oc_deallocatefile(filex); call sseek(x_, 0,0)
 	  		 call oc_deallocatefile(filey); call sseek(yy_,0,0)
 		     stat = 0
		end if !}
  end function oc_mutemod

  !----------------------------------------------------------------

  subroutine oc_mute_clean( )

		deallocate(ng,intendmute,intbegmute)

  end subroutine oc_mute_clean

end module oc_mute_mod
