program SSI_inver  
  use sep 
  use mpi_sep 
  use wei_mig_mid_basic
	use wei_kxmig

  use wei_cig 
  use wei_ssf
  use wei_sll
  use wei_wem 
	use wei_param
	use wei_type

 use oc_global_mod 
  use oc_utils_mod 
  use oc_cgstep_mod 
	use oc_filealgebra_mod
	use oc_filter_mod
	use oc_mpi_combine_mod
  use oc_laplacian_mod
  use oc_mpi_solver_mod 
  use oc_mpi_solverreg_mod
  use oc_mpi_solverpre_mod
  use oc_mpi_dottest_mod 
	use oc_dotme_mod
!	use guber_wei_mod
	use geop_prec_mod
	use guber_2dfilt_wei
	use oc_helicon_mod
	use oc_polydiv_mod
	use oc_scale_mod
	use oc_weight_mod
	use oc_off_pad
	use oc_mute_mod


  implicit none
  integer :: stat
  integer :: mpierr 

  real               :: eps
  integer            :: niter,niter_pr,i,n,nreg(5),ierr,i2d,iverb,iter_restart
	real            :: opx,dpx
  logical            :: verb,dmovie,movie,my2dfilt,restart,pcig,precreg,padded 
	logical						 :: irreg_dat,mute_mod, mute_modbeg	
  integer            :: maxmem,ocsolver,beg_x,beg_y,trueoff_x,trueoff_y
  integer, pointer :: iw(:)
	real               :: hwidth,amp

  character(len=128) :: res,beenprec,x0,name

  type(fileinfo)                   :: file
  !----------------------------------------------------------------
  call MPI_INIT(stat)
  call set_no_putch()
  call sep_init()
  !----------------------------------------------------------------
  !! init params for MPI
  call MPI_COMM_SIZE(MPI_COMM_WORLD, n,ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD, i,ierr)
  if(i==0) then
		 call from_param("verb",verb,.false.)
		 iverb=0;if(verb) iverb=1
     call MPI_SEP_SEND_ARGS(n,10,iverb)
  else
     call MPI_SEP_RECEIVE_ARGS()
  end if


	x0='x0'

!	call initpar()
	call from_param("hwidth",hwidth,1.501)
	call from_param("amp",amp,.95)
	call from_param("niter",niter,3)
	call from_param("res",res,"res")
  call from_param("restart",restart,.false.)
  call from_param("twodfilt",my2dfilt,.false.)
  call from_param("precreg",precreg,.false.)
  call from_param("pCIG",pcig,.true.)
  call from_param("padded",padded,.false.)
  call from_param("irreg_dat",irreg_dat,.false.)
  call from_param("mute_mod",mute_mod,.false.)
  call from_param("mute_modbeg",mute_modbeg,.false.)
!  my2dfilt=.false.
!  if(i2d==1)my2dfilt=.true.
!  write(0,*)"a4 init 2dfilt",my2dfilt
  call from_param("iter_restart",iter_restart,1)

  call from_param("movie", movie ,.false.)
  call from_param("dmovie", dmovie ,.false.)
  call from_param("ocsolver", ocsolver ,0)
  if(ocsolver == 4) call from_param("niter_pr",niter_pr,1)

  call grab_params(niter,eps,maxmem,verb,nreg)

	if(pcig) then   !offset ray parameter

	  !----------------------------------------------------------------
 	 call weimig_init(SLin=weisll_init	&
	 ,			 				 WCin=weikxmign_init &
 	 ,                FKin=weiwem_init	&
 	 ,                FXin=weissf_init	&
 	 ,                IGin=weipcig_init	)
 	 !----------------------------------------------------------------

	opx=down%rsep%o(3)
	dpx=down%rsep%d(3)
	
	if(padded) then
		if(verb .and. i==0) write(0,*)"Padded"
    call from_param("trueoffx",trueoff_x,nreg(3))
    call from_param("trueoffy",trueoff_y,nreg(4))
    call from_param("beg_x",beg_x,1)
    call from_param("beg_y",beg_y,1)
		call oc_offpad_init(irreg_dat,trueoff_x,trueoff_y,beg_x,beg_y,maxmem_in=maxmem)
	end if	

	if(mute_mod) then
		if(verb .and. i==0) write(0,*)"User-defined model mute"
		call oc_mute_init(nreg,opx,dpx,mute_modbeg,maxmem_in=maxmem)
	end if

 	 !! select a solver
 	 select case(ocsolver)

		case(5) !! dottest
!			if(i==0 .and. verb) call weimessage("dottest")
			if(i==0 .and. verb)	write(0,*)"doing dottest init,padded",padded
			call oc_mpi_dottest_init(i,maxmem=maxmem)
			if(i==0 .and. verb)	write(0,*)"doing dottest"
			call oc_dotme_init(i,maxmem=maxmem)
			call geop_prec_init(i,nreg,down%R)
			call oc_mpi_dottest(oc_dotme,down%R,down%D &
      ,           op1=weimig  &
      ,           op2=chain_geop_prec &
      ,           op3=weisll  &
      ,           op4=weikxmign_mid  &
      ,           op5=weiwem &
      ,           op6=weissf  &
      ,           op7=weipcig)
	
!      call oc_mpi_dottest(weimig,down%R,down%D &
!      ,           op1=weisll  &
!      ,           op2=weikxmign_mid  &
!      ,           op3=weiwem &
!      ,           op4=weissf  &
!      ,           op5=weipcig)

		case(6) !! modeling
!			if(i==0 .and. verb) call weimessage("modeling")
	
				stat = weimig(.false.,down%add,down%R,down%D &
			  ,              SLop=weisll  &
 	     ,           WCop=weikxmign_mid  &
 	     ,              FKop=weiwem &
 	     ,              FXop=weissf &
 	     ,              IGop=weipcig)
	
	

		case(0) !! migration
!			if(i==0 .and. verb) call weimessage("migrating")
	
				stat = weimig(down%adj,down%add,down%R,down%D &
			  ,              SLop=weisll  &
 	     ,           WCop=weikxmign_mid  &
 	     ,              FKop=weiwem &
 	     ,              FXop=weissf &
 	     ,              IGop=weipcig)

				if(i==0 .and. verb) write(0,*)"after weimig"

				call mpi_barrier(MPI_COMM_WORLD,ierr)

				if(i==0 .and. mute_mod) then
           name="beenprec"; beenprec = oc_clone(.false., down%R,name, maxmem)
           stat = oc_mutemod(down%adj,down%add,beenprec,down%R)
         end if
	
 	 case(1) !! simple inversion
! 	    if(i==0 .and. verb) call weimessage("solving Lm=D")
	
 	    call oc_mpi_solver_init(i,niter,maxmem,verb,movie,dmovie)
	
 	    call oc_mpi_solver( weimig, oc_cgstep &
 	    ,           down%R,down%D &
 	    ,           op1=weisll	&
 	    ,           op2=weikxmign_mid &
 	    ,           op3=weiwem	&
 	    ,           op4=weissf	&
 	    ,           op5=weipcig) 
	
 	 case(2) !! regularization
! 	    if(i==0 .and. verb) call weimessage("solving WLm=WD & eAm=0")
	
 	    call oc_mpi_solverreg_init(i,niter,eps,maxmem,verb,movie,dmovie)

			if(precreg) then

write(0,*)"reading x0" 

				 call auxinout(x0)
	
				if(my2dfilt) then

					call guber_2dinit(nreg)

					if(padded) then

	 		    	call oc_mpi_solverreg( weimig, oc_guber_2dreg, oc_cgstep, &
 			     	down%R,down%D,nreg=nreg,W=oc_offpad, x0_=x0 &
 			    	,           op1=weisll	&
 			    	,           op2=weikxmign_mid &
 			    	,           op3=weiwem	&
 			    	,           op4=weissf	&
 			    	,           op5=weipcig )

					else

	 		    	call oc_mpi_solverreg( weimig, oc_guber_2dreg, oc_cgstep, &
 			     	down%R,down%D, nreg=nreg, x0_=x0 &
 			    	,           op1=weisll	&
 			    	,           op2=weikxmign_mid &
 			    	,           op3=weiwem	&
 			    	,           op4=weissf	&
 			    	,           op5=weipcig )

					end if

				else

					call geop_prec_init(i,nreg,down%R)
	
					if(padded) then

	 		    	call oc_mpi_solverreg( weimig, chain_geop_reg, oc_cgstep, &
 			     	down%R,down%D, nreg=nreg, W=oc_offpad, x0_=x0 &
 			    	,           op1=weisll	&
 			    	,           op2=weikxmign_mid &
 			    	,           op3=weiwem	&
 			    	,           op4=weissf	&
 			    	,           op5=weipcig )
	
					else
	
	 		    	call oc_mpi_solverreg( weimig, chain_geop_reg, oc_cgstep, &
 			     	down%R,down%D, nreg=nreg, x0_=x0 &
 			    	,           op1=weisll	&
 			    	,           op2=weikxmign_mid &
 			    	,           op3=weiwem	&
 			    	,           op4=weissf	&
 			    	,           op5=weipcig )

					end if
	
				end if

			else

				if(my2dfilt) then

					call guber_2dinit(nreg)

					if(padded) then

 		   	 	call oc_mpi_solverreg( weimig, oc_guber_2dreg, oc_cgstep, &
 		   	  	down%R,down%D, nreg=nreg,W=oc_offpad &
 		   		 	,           op1=weisll	&
 		   		 	,           op2=weikxmign_mid &
 		   		 	,           op3=weiwem	&
 		   		 	,           op4=weissf	&
 		   		 	,           op5=weipcig )

					else

 		   	 	call oc_mpi_solverreg( weimig, oc_guber_2dreg, oc_cgstep, &
 		   	  	down%R,down%D, nreg=nreg &
 		   		 	,           op1=weisll	&
 		   		 	,           op2=weikxmign_mid &
 		   		 	,           op3=weiwem	&
 		   		 	,           op4=weissf	&
 		   		 	,           op5=weipcig )

					end if

				else

					call geop_prec_init(i,nreg,down%R)
	
					if(padded) then

 		  	  	call oc_mpi_solverreg( weimig,chain_geop_reg, oc_cgstep, &
 		   	  	down%R,down%D, nreg=nreg,W=oc_offpad &
 		   		 	,           op1=weisll	&
 		   		 	,           op2=weikxmign_mid &
 		   		 	,           op3=weiwem	&
 		   		 	,           op4=weissf	&
 		   		 	,           op5=weipcig )

					else

 		  	  	call oc_mpi_solverreg( weimig,chain_geop_reg, oc_cgstep, &
 		   	  	down%R,down%D, nreg=nreg &
 		   		 	,           op1=weisll	&
 		   		 	,           op2=weikxmign_mid &
 		   		 	,           op3=weiwem	&
 		   		 	,           op4=weissf	&
 		   		 	,           op5=weipcig )

					end if
	
				end if

			endif
	
 	 case(3) !! preconditioning
! 	    if(i==0 .and. verb) call weimessage("solving WLP p=WD &  eIp=0")
	
! 	    eps = 0.
	
 	    call oc_mpi_solverpre_init(i,niter,eps,maxmem,verb,movie,dmovie)
	
			 if(my2dfilt) then

				call guber_2dinit(nreg)

				if(padded) then

 	  	 	 call oc_mpi_solverpre( weimig, oc_guber_2dprec, oc_cgstep, &
 	  	 	 down%R, down%D, npre=nreg, W=oc_offpad &
 	  	 	 ,           op1=weisll &
 	  	 	 ,           op2=weikxmign_mid &
 	  	 	 ,           op3=weiwem	&
 	  	 	 ,           op4=weissf	&
 	  	 	 ,           op5=weipcig )

				else
	
 	  	 	 call oc_mpi_solverpre( weimig, oc_guber_2dprec, oc_cgstep, &
 	  	 	 down%R, down%D, npre=nreg &
 	  	 	 ,           op1=weisll &
 	  	 	 ,           op2=weikxmign_mid &
 	  	 	 ,           op3=weiwem	&
 	  	 	 ,           op4=weissf	&
 	  	 	 ,           op5=weipcig )

				end if

			 else

				call geop_prec_init(i,nreg,down%R)	

				if(padded) then

!write(0,*)"about to call oc_mpi_solverpre"
 		  	  call oc_mpi_solverpre( weimig,chain_geop_prec, oc_cgstep, &
 	 		 	  down%R, down%D, npre=nreg, W=oc_offpad  &
 	 		 	  ,           op1=weisll &
 	 		 	  ,           op2=weikxmign_mid &
 	 		 	  ,           op3=weiwem	&
 	 		 	  ,           op4=weissf	&
 	 		 	  ,           op5=weipcig )

				else
	
 		  	  call oc_mpi_solverpre( weimig,chain_geop_prec, oc_cgstep, &
 	 		 	  down%R, down%D, npre=nreg  &
 	 		 	  ,           op1=weisll &
 	 		 	  ,           op2=weikxmign_mid &
 	 		 	  ,           op3=weiwem	&
 	 		 	  ,           op4=weissf	&
 	 		 	  ,           op5=weipcig )

				end if

			 end if
	
 	 case(4) !! preconditioning followed by regularization
! 	    if(i==0 .and. verb) call weimessage("Prec and reg")
	
 	    call oc_mpi_solverpre_init(i,niter,eps,maxmem,verb,movie,dmovie)
 	    call oc_mpi_solverreg_init(i,niter_pr,eps,maxmem,verb,movie,dmovie)
	
			 if(my2dfilt) then

				 call guber_2dinit(nreg)
	
				 beenprec=down%R
	
				if(padded) then

			     call oc_mpi_solverpre( weimig, oc_guber_2dprec, oc_cgstep, &
 			     beenprec, down%D, npre=nreg,W=oc_offpad &
 			     ,           op1=weisll &
 			     ,           op2=weikxmign_mid &
 			     ,           op3=weiwem	&
 			     ,           op4=weissf	&
 			     ,           op5=weipcig )
	
 	  	   	call oc_mpi_solverreg( weimig, oc_guber_2dreg, oc_cgstep, &
 	  	   	down%R,down%D, nreg=nreg, W=oc_offpad, x0_=beenprec  &
 	 	 	  ,           op1=weisll	&
 	  		   ,           op2=weikxmign_mid &
 	  		   ,           op3=weiwem	&
 	  		   ,           op4=weissf	&
 	  		   ,           op5=weipcig )
	
				else	
	
			     call oc_mpi_solverpre( weimig, oc_guber_2dprec, oc_cgstep, &
 			     beenprec, down%D, npre=nreg &
 			     ,           op1=weisll &
 			     ,           op2=weikxmign_mid &
 			     ,           op3=weiwem	&
 			     ,           op4=weissf	&
 			     ,           op5=weipcig )

	
!			   call auxinout(beenprec)
 	  	  	 call oc_mpi_solverreg( weimig, oc_guber_2dreg, oc_cgstep, &
 	  	   	down%R,down%D, nreg=nreg, x0_=beenprec  &
 	 		   ,           op1=weisll	&
 	 		 	   ,           op2=weikxmign_mid &
 	 		 	   ,           op3=weiwem	&
 	 		 	   ,           op4=weissf	&
 	 		 	   ,           op5=weipcig )
	
				end if

			 else
	
				 call geop_prec_init(i,nreg,down%R)
				 beenprec=down%R
	
				if(padded) then

			     call oc_mpi_solverpre( weimig,chain_geop_prec, oc_cgstep, &
 			     beenprec, down%D, npre=nreg, W=oc_offpad  &
 			     ,           op1=weisll &
 			     ,           op2=weikxmign_mid &
 			     ,           op3=weiwem	&
 			     ,           op4=weissf	&
 			     ,           op5=weipcig )
	
 	  	   	call oc_mpi_solverreg( weimig,chain_geop_reg, oc_cgstep, &
 	  		   down%R,down%D, nreg=nreg, W=oc_offpad, x0_=beenprec  &
 	 	   	,           op1=weisll	&
 	  	 	  ,           op2=weikxmign_mid &
 	  	 	  ,           op3=weiwem	&
 	  	 	  ,           op4=weissf	&
 	  	 	  ,           op5=weipcig )

				else

			     call oc_mpi_solverpre( weimig,chain_geop_prec, oc_cgstep, &
 			     beenprec, down%D, npre=nreg  &
 			     ,           op1=weisll &
 			     ,           op2=weikxmign_mid &
 			     ,           op3=weiwem	&
 			     ,           op4=weissf	&
 			     ,           op5=weipcig )
	
 	  	   	call oc_mpi_solverreg( weimig,chain_geop_reg, oc_cgstep, &
 	  		   down%R,down%D, nreg=nreg, x0_=beenprec  &
 	 	   	,           op1=weisll	&
 	  	 	  ,           op2=weikxmign_mid &
 	  	 	  ,           op3=weiwem	&
 	  	 	  ,           op4=weissf	&
 	  	 	  ,           op5=weipcig )

				end if
	
			 end if
	
 	 case default
 	    call seperr('unknown operation')
 	 end select
	else   !offset
	  !----------------------------------------------------------------
 	 call weimig_init(SLin=weisll_init	&
	 ,			 				 WCin=weikxmign_init &
 	 ,                FKin=weiwem_init	&
 	 ,                FXin=weissf_init	&
 	 ,                IGin=weihcig_init	)
 	 !----------------------------------------------------------------
	if(padded) then
		if(verb) write(0,*)"Padded"
    call from_param("trueoffx",trueoff_x,nreg(3))
    call from_param("trueoffy",trueoff_y,nreg(4))
    call from_param("beg_x",beg_x,1)
    call from_param("beg_y",beg_y,1)
		call oc_offpad_init(irreg_dat,trueoff_x,trueoff_y,beg_x,beg_y,maxmem_in=maxmem)
	end if	

	if(mute_mod) then
		if(verb) write(0,*)"User-defined model mute"
		call oc_mute_init(nreg,opx,dpx,mute_modbeg,maxmem_in=maxmem)
	end if
	
 	 !! select a solver
 	 select case(ocsolver)

		case(5) !! dottest
!			if(i==0 .and. verb) call weimessage("dottest")

			call oc_mpi_dottest_init(i,maxmem=maxmem)
      call oc_mpi_dottest(weimig,down%R,down%D &
      ,           op1=weisll  &
      ,           op2=weikxmign_mid  &
      ,           op3=weiwem &
      ,           op4=weissf  &
      ,           op5=weihcig)

		case(6) !! modeling
!			if(i==0 .and. verb) call weimessage("modeling")
	
				stat = weimig(.false.,down%add,down%R,down%D &
			  ,              SLop=weisll  &
 	     ,           WCop=weikxmign_mid  &
 	     ,              FKop=weiwem &
 	     ,              FXop=weissf &
 	     ,              IGop=weihcig)
	
		case(0) !! migration
!			if(i==0 .and. verb) call weimessage("migrating")
	
				stat = weimig(down%adj,down%add,down%R,down%D &
			  ,              SLop=weisll  &
 	     ,           WCop=weikxmign_mid  &
 	     ,              FKop=weiwem &
 	     ,              FXop=weissf &
 	     ,              IGop=weihcig)
	
	
 	 case(1) !! simple inversion
! 	    if(i==0 .and. verb) call weimessage("solving Lm=D")
	
 	    call oc_mpi_solver_init(i,niter,maxmem,verb,movie,dmovie)
	
 	    call oc_mpi_solver( weimig, oc_cgstep &
 	    ,           down%R,down%D &
 	    ,           op1=weisll	&
 	    ,           op2=weikxmign_mid &
 	    ,           op3=weiwem	&
 	    ,           op4=weissf	&
 	    ,           op5=weihcig) 
	
 	 case(2) !! regularization
! 	    if(i==0 .and. verb) call weimessage("solving WLm=WD & eAm=0")
	
 	    call oc_mpi_solverreg_init(i,niter,eps,maxmem,verb,movie,dmovie)

			if(my2dfilt) then

				call guber_2dinit(nreg)

 	    	call oc_mpi_solverreg( weimig, oc_guber_2dreg, oc_cgstep, &
 	     	down%R,down%D, nreg=nreg  &
 	    	,           op1=weisll	&
 	    	,           op2=weikxmign_mid &
 	    	,           op3=weiwem	&
 	    	,           op4=weissf	&
 	    	,           op5=weihcig )


			else

				call geop_prec_init(i,nreg,down%R)
	
	 	    call oc_mpi_solverreg( weimig,chain_geop_reg, oc_cgstep, &
 		     down%R,down%D, nreg=nreg  &
 		    ,           op1=weisll	&
 		    ,           op2=weikxmign_mid &
 		    ,           op3=weiwem	&
 		    ,           op4=weissf	&
 		    ,           op5=weihcig )

			end if
	
 	 case(3) !! preconditioning
! 	    if(i==0 .and. verb) call weimessage("solving WLP p=WD &  eIp=0")
	
 	    eps = 0.
	
 	    call oc_mpi_solverpre_init(i,niter,eps,maxmem,verb,movie,dmovie)
	
			 if(my2dfilt) then
	
				call guber_2dinit(nreg)

 	  	  call oc_mpi_solverpre( weimig, oc_guber_2dprec, oc_cgstep, &
 	  	  down%R, down%D, npre=nreg  &
 	  	  ,           op1=weisll &
 	  	  ,           op2=weikxmign_mid &
 	  	  ,           op3=weiwem	&
 	  	  ,           op4=weissf	&
 	  	  ,           op5=weihcig )
	
			 else
	
				call geop_prec_init(i,nreg,down%R)

 	  	  call oc_mpi_solverpre( weimig,chain_geop_prec, oc_cgstep, &
 	  	  down%R, down%D, npre=nreg  &
 	  	  ,           op1=weisll &
 	  	  ,           op2=weikxmign_mid &
 	  	  ,           op3=weiwem	&
 	  	  ,           op4=weissf	&
 	  	  ,           op5=weihcig )
	
			 end if
	
 	 case(4) !! preconditioning followed by regularization
! 	    if(i==0 .and. verb) call weimessage("Prec and reg")
	
 	    call oc_mpi_solverpre_init(i,niter,eps,maxmem,verb,movie,dmovie)
 	    call oc_mpi_solverreg_init(i,niter_pr,eps,maxmem,verb,movie,dmovie)
	
			 if(my2dfilt) then
	
				 call guber_2dinit(nreg)

				 beenprec=down%R
	
		     call oc_mpi_solverpre( weimig, oc_guber_2dprec, oc_cgstep, &
 		     beenprec, down%D, npre=nreg  &
 		     ,           op1=weisll &
 		     ,           op2=weikxmign_mid &
 		     ,           op3=weiwem	&
 		     ,           op4=weissf	&
 		     ,           op5=weihcig )
	
			   call auxinout(beenprec)
 	  	   call oc_mpi_solverreg( weimig, oc_guber_2dreg, oc_cgstep, &
 	  	   down%R,down%D, nreg=nreg, x0_=beenprec  &
 	 	   ,           op1=weisll	&
 	  	   ,           op2=weikxmign_mid &
 	  	   ,           op3=weiwem	&
 	  	   ,           op4=weissf	&
 	  	   ,           op5=weihcig )
	
			 else
	
				 call geop_prec_init(i,nreg,down%R)

				 beenprec=down%R
	
		     call oc_mpi_solverpre( weimig, chain_geop_prec, oc_cgstep, &
 		     beenprec, down%D, npre=nreg  &
 		     ,           op1=weisll &
 		     ,           op2=weikxmign_mid &
 		     ,           op3=weiwem	&
 		     ,           op4=weissf	&
 		     ,           op5=weihcig )
	
	
			   call auxinout(beenprec)
 	  	   call oc_mpi_solverreg( weimig,chain_geop_reg, oc_cgstep, &
 	  	   down%R,down%D, nreg=nreg, x0_=beenprec  &
 	 	   ,           op1=weisll	&
 	  	   ,           op2=weikxmign_mid &
 	  	   ,           op3=weiwem	&
 	  	   ,           op4=weissf	&
 	  	   ,           op5=weihcig )
	
			 end if

 	 case default
 	    call seperr('unknown operation')
 	 end select

	end if
	
!  if(verb) call weimessage("OK")
  !----------------------------------------------------------------  
  !! shutdown MPI
  call MPI_FINALIZE(ierr) 
  !----------------------------------------------------------------
  call exit(0)
end program SSI_inver
